// EditConDispatch.cpp : implementation file
//

#include "stdafx.h"
#include "mfcaxscrvb.h"
#include "EditConDispatch.h"
#include "mfcaxscrvbDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Note: we add support for IID_IEditConDispatch to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {B2C1A343-4F18-11D0-A1AE-000000000000}
static const IID IID_IEditConDispatch =
{ 0xb2c1a343, 0x4f18, 0x11d0, { 0xa1, 0xae, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

// {B2C1A344-4F18-11D0-A1AE-000000000000}
static const IID IID_IEditConEvents =
{ 0xb2c1a344, 0x4f18, 0x11d0, { 0xa1, 0xae, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

// {B2C1A345-4F18-11D0-A1AE-000000000000}
// coclass!
static const GUID CLSID_EditCon =
{ 0xb2c1a345, 0x4f18, 0x11d0, { 0xa1, 0xae, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

// Use OLETYPELIB of master dialog?
IMPLEMENT_OLETYPELIB(CEditConDispatch, _tlid, _wVerMajor, _wVerMinor)

/////////////////////////////////////////////////////////////////////////////
// CEditConDispatch

IMPLEMENT_DYNCREATE(CEditConDispatch, CCmdTargetPlus)

CEditConDispatch::CEditConDispatch()
{
	m_piidEvents = &IID_IEditConEvents;
	m_piidPrimary = &IID_IEditConDispatch;
}

CEditConDispatch::~CEditConDispatch()
{
}


void CEditConDispatch::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTargetPlus::OnFinalRelease();
}

HRESULT CEditConDispatch::GetClassID(LPCLSID pclsid)
{
	*pclsid = CLSID_EditCon;
	return NOERROR;
}

BEGIN_MESSAGE_MAP(CEditConDispatch, CCmdTargetPlus)
	//{{AFX_MSG_MAP(CEditConDispatch)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CEditConDispatch, CCmdTargetPlus)
	//{{AFX_DISPATCH_MAP(CEditConDispatch)
	DISP_FUNCTION(CEditConDispatch, "AppendLine", AppendLine, VT_VARIANT, VTS_VARIANT)
	DISP_FUNCTION(CEditConDispatch, "InsertLine", InsertLine, VT_VARIANT, VTS_VARIANT VTS_VARIANT)
	DISP_FUNCTION(CEditConDispatch, "RemoveLine", RemoveLine, VT_VARIANT, VTS_VARIANT)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

BEGIN_INTERFACE_MAP(CEditConDispatch, CCmdTargetPlus)
	INTERFACE_PART(CEditConDispatch, IID_IEditConDispatch, Dispatch)
END_INTERFACE_MAP()

BEGIN_EVENT_MAP(CEditConDispatch, CCmdTargetPlus)
	//{{AFX_EVENT_MAP(CEditConDispatch)
	EVENT_CUSTOM("OnMouseOver", FireOnMouseOver, VTS_NONE)
	EVENT_CUSTOM("OnChar", FireOnChar, VTS_VARIANT)
	EVENT_CUSTOM("OnFocus", FireOnFocus, VTS_VARIANT)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditConDispatch message handlers

VARIANT CEditConDispatch::AppendLine(const VARIANT FAR& strToAdd) 
{
	ASSERT_VALID(m_pThisWnd); // Did you remember to hook me up to the window object?
	VARIANT vaResult;
	VariantInit(&vaResult);
	vaResult.vt = VT_EMPTY;

	if (VT_BSTR != strToAdd.vt)
	{
		TRACE("AppendLine: didn't get a BSTR\n");
		return vaResult;
	}
	CString strAddText = strToAdd.bstrVal;
	strAddText = "\r\n" + strAddText;

	// save current selection
	int nStartCharOld, nEndCharOld;
	((CEdit*)m_pThisWnd)->GetSel(nStartCharOld, nEndCharOld);

	// set selection to last char of edit control
	int nLines = ((CEdit*)m_pThisWnd)->GetLineCount();
	int nLastIndex = ((CEdit*)m_pThisWnd)->LineIndex(nLines-1);
	int nLastLength = ::SendMessage(m_pThisWnd->m_hWnd, EM_LINELENGTH, (WPARAM) nLastIndex, 0);
	int nLastChar = nLastIndex + nLastLength;
	((CEdit*)m_pThisWnd)->SetSel(nLastChar, nLastChar);

	// replace last selection with new line
	((CEdit*)m_pThisWnd)->ReplaceSel(strAddText, TRUE);

	// restore current selection
	((CEdit*)m_pThisWnd)->SetSel(nStartCharOld, nEndCharOld);

	return vaResult;
}

VARIANT CEditConDispatch::InsertLine(const VARIANT FAR& strToAdd, const VARIANT FAR& nWhere) 
{
	ASSERT_VALID(m_pThisWnd); // Did you remember to hook me up to the window object?
	VARIANT vaResult;
	VariantInit(&vaResult);
	
	if (VT_BSTR != strToAdd.vt)
	{
		TRACE("InsertLine: didn't get a BSTR\n");
		return vaResult;
	}
	CString strAddText = strToAdd.bstrVal;
	strAddText = strAddText + "\r\n";

	if (VT_I2 != nWhere.vt)
	{
		TRACE("InsertLine: didn't get an I2\n");
		return vaResult;
	}

	int nInsertLine = nWhere.iVal;

	// save current selection
	int nStartCharOld, nEndCharOld;
	((CEdit*)m_pThisWnd)->GetSel(nStartCharOld, nEndCharOld);

	// set selection to last char of request line in edit control
	int nLines = ((CEdit*)m_pThisWnd)->GetLineCount();
	if (nInsertLine >= nLines || nInsertLine < 0)
	{
		// bad value
		TRACE("InsertLine: bad line #\n");
		return vaResult;
	}

	int nIndex = ((CEdit*)m_pThisWnd)->LineIndex(nInsertLine);
	int nLength = ::SendMessage(m_pThisWnd->m_hWnd, EM_LINELENGTH, (WPARAM) nIndex, 0);
	int nLastChar = nIndex + nLength + 2;
	((CEdit*)m_pThisWnd)->SetSel(nLastChar, nLastChar);

	// replace last selection with new line
	((CEdit*)m_pThisWnd)->ReplaceSel(strAddText, TRUE);

	// restore current selection
	((CEdit*)m_pThisWnd)->SetSel(nStartCharOld, nEndCharOld);

	return vaResult;
}

VARIANT CEditConDispatch::RemoveLine(const VARIANT FAR& nWhere) 
{
	ASSERT_VALID(m_pThisWnd); // Did you remember to hook me up to the window object?
	VARIANT vaResult;
	VariantInit(&vaResult);
	vaResult.vt = VT_EMPTY;

	if (VT_I2 != nWhere.vt)
	{
		TRACE("RemoveLine: didn't get an I2\n");
		return vaResult;
	}

	int nRemoveLine = nWhere.iVal;

	// save current selection
	int nStartCharOld, nEndCharOld;
	((CEdit*)m_pThisWnd)->GetSel(nStartCharOld, nEndCharOld);

	// set selection to last char of request line in edit control
	int nLines = ((CEdit*)m_pThisWnd)->GetLineCount();
	if (nRemoveLine >= nLines || nRemoveLine < 0)
	{
		// bad value
		TRACE("RemoveLine: bad line #\n");
		return vaResult;
	}

	int nIndex = ((CEdit*)m_pThisWnd)->LineIndex(nRemoveLine);
	int nLength = ::SendMessage(m_pThisWnd->m_hWnd, EM_LINELENGTH, (WPARAM) nIndex, 0);
	int nLastChar = nIndex + nLength + 2;
	((CEdit*)m_pThisWnd)->SetSel(nIndex, nLastChar);

	// replace last selection with new line
	((CEdit*)m_pThisWnd)->Clear();

	// was selection or part of selection removed?
	if (nStartCharOld < nIndex) ; //ok
	else if (nStartCharOld <= nLastChar) // inside line
		nStartCharOld = nIndex - 1;
	else // beyond removed line
		nStartCharOld -= nLength;
	if (nEndCharOld < nIndex) ; //ok
	else if (nEndCharOld <= nLastChar) // inside line
		nEndCharOld = nIndex - 1;
	else // beyond removed line
		nEndCharOld -= nLength;

	// restore current selection
	((CEdit*)m_pThisWnd)->SetSel(nStartCharOld, nEndCharOld);
	return vaResult;
}
