// LBoxDispatch.cpp : implementation file
//

#include "stdafx.h"
#include "mfcaxscrvb.h"

#include "LBoxDispatch.h"

#include "mfcaxscrvbDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Note: we add support for IID_ILBoxDispatch to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {2BC41DB5-422F-11D0-A1A9-000000000000}
static const IID IID_ILBoxDispatch =
{ 0x2bc41db5, 0x422f, 0x11d0, { 0xa1, 0xa9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

// {2BC41DB6-422F-11D0-A1A9-000000000000}
static const IID IID_ILBoxEvents =
{ 0x2bc41db6, 0x422f, 0x11d0, { 0xa1, 0xa9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

// {2BC41DB7-422F-11D0-A1A9-000000000000}
// coclass!
static const GUID CLSID_LBox =
{ 0x2bc41db7, 0x422f, 0x11d0, { 0xa1, 0xa9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

// Use OLETYPELIB of master dialog?
IMPLEMENT_OLETYPELIB(CLBoxDispatch, _tlid, _wVerMajor, _wVerMinor)

/////////////////////////////////////////////////////////////////////////////
// CLBoxDispatch

IMPLEMENT_DYNCREATE(CLBoxDispatch, CCmdTargetPlus)

CLBoxDispatch::CLBoxDispatch()
{
	// Need this now? EnableAutomation();

	m_piidEvents = &IID_ILBoxEvents;
	m_piidPrimary = &IID_ILBoxDispatch;

}

CLBoxDispatch::~CLBoxDispatch()
{
}


void CLBoxDispatch::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTargetPlus::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CLBoxDispatch, CCmdTargetPlus)
	//{{AFX_MSG_MAP(CLBoxDispatch)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CLBoxDispatch, CCmdTargetPlus)
	//{{AFX_DISPATCH_MAP(CLBoxDispatch)
	DISP_FUNCTION(CLBoxDispatch, "AddString", AddString, VT_EMPTY, VTS_VARIANT)
	DISP_FUNCTION(CLBoxDispatch, "ClearList", ClearList, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CLBoxDispatch, "RemoveString", RemoveString, VT_EMPTY, VTS_VARIANT)
	DISP_FUNCTION(CLBoxDispatch, "SelectString", SelectString, VT_EMPTY, VTS_VARIANT)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()


BEGIN_INTERFACE_MAP(CLBoxDispatch, CCmdTargetPlus)
	INTERFACE_PART(CLBoxDispatch, IID_ILBoxDispatch, Dispatch)
END_INTERFACE_MAP()

BEGIN_EVENT_MAP(CLBoxDispatch, CCmdTargetPlus)
	//{{AFX_EVENT_MAP(CLBoxDispatch)
	EVENT_CUSTOM("OnMouseOver", FireOnMouseOver, VTS_NONE)
	EVENT_CUSTOM("OnFocus", FireOnFocus, VTS_BOOL)
	EVENT_CUSTOM("OnSelCancel", FireOnSelCancel, VTS_VARIANT)
	EVENT_CUSTOM("OnSelChange", FireOnSelChange, VTS_VARIANT)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


HRESULT CLBoxDispatch::GetClassID(LPCLSID pclsid)
{
	*pclsid = CLSID_LBox;
	return NOERROR;
}

/////////////////////////////////////////////////////////////////////////////
// CLBoxDispatch message handlers

void CLBoxDispatch::AddString(const VARIANT FAR& strAdd) 
{
	ASSERT_VALID(m_pThisWnd); // did you remember to hook me up to the window object?
	COleVariant vtStrIn(strAdd);
	CString strAddMe;
	BOOL bConvert = TRUE;

	if (strAdd.vt == VT_BSTR)
	{
		strAddMe = (LPCWSTR) vtStrIn.pbstrVal;
	}
	else
	{
		// attempt to convert
		try
		{
			vtStrIn.ChangeType(VT_BSTR);
		}
		catch(CException* e)
		{
			e->Delete();
			goto AintGoanDoIt;
		}
		strAddMe = (LPCWSTR) vtStrIn.pbstrVal;
	}

	((CListBox*)m_pThisWnd)->AddString(strAddMe);

AintGoanDoIt:

		return;
}

void CLBoxDispatch::ClearList() 
{
	ASSERT_VALID(m_pThisWnd); // did you remember to hook me up to the window object?
	((CListBox*)m_pThisWnd)->ResetContent();
	return;

}

void CLBoxDispatch::RemoveString(const VARIANT FAR& strRemove) 
{
	ASSERT_VALID(m_pThisWnd); // did you remember to hook me up to the window object?
	COleVariant vtStrIn(strRemove);
	CString strRemoveMe;
	BOOL bConvert = TRUE;
	int nStr;

	if (strRemove.vt == VT_BSTR)
	{
		strRemoveMe = (LPCWSTR) vtStrIn.pbstrVal;
	}
	else
	{
		// attempt to convert
		try
		{
			vtStrIn.ChangeType(VT_BSTR);
		}
		catch(CException* e)
		{
			e->Delete();
			goto AintGoanDoIt;
		}
		strRemoveMe = (LPCWSTR) vtStrIn.pbstrVal;
	}

	nStr = ((CListBox*)m_pThisWnd)->FindString(-1, strRemoveMe);
	if (LB_ERR == nStr)
	{
		TRACE0("Error: String not found in RemoveString");
		goto AintGoanDoIt;
	}

	((CListBox*)m_pThisWnd)->DeleteString(nStr);

AintGoanDoIt:

		return;

}

void CLBoxDispatch::SelectString(const VARIANT FAR& strSelect) 
{
	ASSERT_VALID(m_pThisWnd); // did you remember to hook me up to the window object?
	COleVariant vtStrIn(strSelect);
	CString strSelectMe;
	BOOL bConvert = TRUE;

	if (strSelect.vt == VT_BSTR)
	{
		strSelectMe = (LPCWSTR) vtStrIn.pbstrVal;
	}
	else
	{
		// attempt to convert
		try
		{
			vtStrIn.ChangeType(VT_BSTR);
		}
		catch(CException* e)
		{
			e->Delete();
			goto AintGoanDoIt;
		}
		strSelectMe = (LPCWSTR) vtStrIn.pbstrVal;
	}

	((CListBox*)m_pThisWnd)->SelectString(-1, strSelectMe);

AintGoanDoIt:

		return;

}
