// mfcaxscrvbDlg.h : header file
//

#include "AButtonDispatch.h"
#include "BButtonDispatch.h"
#include "LBoxDispatch.h"
#include "EditConDispatch.h"
#include "RunScriptDispatch.h"
#include "EventsButton.h"
#include "EventsListBox.h"
#include "EventsEdit.h"
#include "OKDispatch.h"
#include "CancelDispatch.h"

#include <activscp.h>
#include "activscp_plus.h"

//{{AFX_INCLUDES()
#include "webbrowser.h"
//}}AFX_INCLUDES

#ifndef __MFCAXSCRVBDLG_H__
#define __MFCAXSCRVBDLG_H__

/////////////////////////////////////////////////////////////////////////////
// CMfcaxscrvbDlg dialog

class CMfcaxscrvbDlg : public CDialog
{
// Construction
public:
	CMfcaxscrvbDlg(CWnd* pParent = NULL);	// standard constructor
	~CMfcaxscrvbDlg();

// XX ActiveX Scripting XX
	BOOL CreateEngine();
	CMapStringToOb mapNamedItems;
	BOOL m_bScriptIsRunning;
	IActiveScriptParse* m_axsp;
	IActiveScript* m_axs;

// XX ActiveX Scripting with debug support XX
   IProcessDebugManager* m_pdm;
   IDebugApplication*    m_pDebugApp;
   IDebugDocumentHelper* m_pDebugDocHelper;
   CString               m_strCurrentFilePath;
   DWORD                 m_dwAppCookie;

	// Object model dispatch objects
	CLBoxDispatch		m_xLBoxDispatch;
	CAButtonDispatch	m_xAButtonDispatch;
	CBButtonDispatch	m_xBButtonDispatch;
	COKDispatch			m_xOKDispatch;
	CCancelDispatch		m_xCancelDispatch;
	CEditConDispatch	m_xEditConDispatch;
	CRunScriptDispatch	m_xRunScriptDispatch;
// XX ActiveX Scripting XX

// Dialog Data
	//{{AFX_DATA(CMfcaxscrvbDlg)
	enum { IDD = IDD_MFCAXSCRVB_DIALOG };
	CEventsButton	m_wndBButton;
	CEventsButton	m_wndRunScript;
	CEventsEdit	m_wndEditCon;
	CEventsButton m_wndAButton;
	CEventsListBox	m_wndLBox;
	CWebBrowser	m_wndBroCon;
	CEventsButton m_wndOK;
	CEventsButton m_wndCancel;
	BOOL	m_bBreakOnStart;
	//}}AFX_DATA
	
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMfcaxscrvbDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

	void OnFinalRelease();

	DECLARE_OLETYPELIB(CMfcaxscrvbDlg)
	GetDispatchIID(IID*);

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CMfcaxscrvbDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnRunScript();
	afx_msg void OnBbuttonClicked();
	afx_msg void OnOpenDebugger();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	DECLARE_INTERFACE_MAP()
	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(CMfcaxscrvbDlg)
	afx_msg LPDISPATCH GetBroCon();
	afx_msg LPDISPATCH GetEditCon();
	afx_msg LPDISPATCH GetAButton();
	afx_msg LPDISPATCH GetBButton();
	afx_msg LPDISPATCH GetLBox();
	afx_msg LPDISPATCH GetScriptButton();
	afx_msg LPDISPATCH GetOKButton();
	afx_msg LPDISPATCH GetCancelButton();
	afx_msg LPDISPATCH HostCreateObject(const VARIANT FAR& bstrProgID);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	BEGIN_INTERFACE_PART(ActiveScriptSite, IActiveScriptSite)
		STDMETHOD(GetLCID)(LCID*);
		STDMETHOD(GetItemInfo)(LPCOLESTR, DWORD, LPUNKNOWN*, LPTYPEINFO*);
        STDMETHOD(GetDocVersionString)(BSTR*);
        STDMETHOD(OnScriptTerminate)(const VARIANT*, const EXCEPINFO*);
        STDMETHOD(OnStateChange)(SCRIPTSTATE);
        STDMETHOD(OnScriptError)(IActiveScriptError*);
        STDMETHOD(OnEnterScript)();
        STDMETHOD(OnLeaveScript)();
	END_INTERFACE_PART(ActiveScriptSite)

	BEGIN_INTERFACE_PART(ActiveScriptSiteWindow, IActiveScriptSiteWindow)
		STDMETHOD(EnableModeless)(BOOL);
		STDMETHOD(GetWindow)(HWND*);
	END_INTERFACE_PART(ActiveScriptSiteWindow)

	BEGIN_INTERFACE_PART(ActiveScriptSiteDebug, IActiveScriptSiteDebug)
		STDMETHOD(GetDocumentContextFromPosition)(DWORD, ULONG, ULONG, IDebugDocumentContext**);
		STDMETHOD(GetApplication)(IDebugApplication**);
		STDMETHOD(GetRootApplicationNode)(IDebugApplicationNode**);
      STDMETHOD(OnScriptErrorDebug)(IActiveScriptErrorDebug*, BOOL*, BOOL*);
	END_INTERFACE_PART(ActiveScriptSiteDebug)

	BEGIN_INTERFACE_PART(DebugDocumentHost, IDebugDocumentHost)
      STDMETHOD(GetDeferredText)(DWORD, WCHAR*, SOURCE_TEXT_ATTR*, ULONG*, ULONG); 
      STDMETHOD(GetScriptTextAttributes)(LPCOLESTR, ULONG, LPCOLESTR, DWORD, SOURCE_TEXT_ATTR*); 
      STDMETHOD(OnCreateDocumentContext)(IUnknown**); 
      STDMETHOD(GetPathName)(BSTR*, BOOL*); 
      STDMETHOD(GetFileName)(BSTR*); 
      STDMETHOD(NotifyChanged)(); 
	END_INTERFACE_PART(DebugDocumentHost)
};

extern const GUID CDECL BASED_CODE _tlid;
extern const WORD _wVerMajor;
extern const WORD _wVerMinor;

#endif // __MFCAXSCRVBDLG_H__
